-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  Globals  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local ADHEALTH, Core 					= 			...
BraveReward 							= 			LibStub("AceAddon-3.0"):NewAddon(ADHEALTH, "AceConsole-3.0", "AceEvent-3.0")
local ACR 								= 			LibStub("AceConfigRegistry-3.0")
local AceConfigDialog 					= 			LibStub("AceConfigDialog-3.0")

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  Frames  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local f 								= 			CreateFrame("Frame")
local hbtext 							=			CreateFrame("Frame", "hbtext", UIParent)
local HealthBarText 					= 			hbtext:CreateFontString("HealthBarText", "OVERLAY", UIParent)

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  FRAME  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local bossIcon_offset					=			{-20, 45}
local bossIcon_scale					=			0.9

local bossIcon_bg						=			CreateFrame("Frame", "bossIcon_container")
	  bossIcon_bg:SetFrameStrata("MEDIUM")
local bossIcon_bg_coord					=			{0.01, 0.64, 0.22, 0.275}
local bossIcon_bg_iconW					=			320 -- 320
local bossIcon_bg_iconH					=			50 -- 50
local bossIcon_bg_scale					=			0.9
local bossIconBgTex						=			"UI-EncounterJournalTextures.blp"

-------------------------------------------------------------------------------------------------------------------------------
		--------------------------------------------  Enchants and Flasks  --------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local enchants = {

	--------- RINGS ---------

	-- Wort des kritischen Treffers +150
	[5423] = 150,
	-- Wort des Tempos +150
	[5424] = 150,
	-- Wort der Meisterschaft +150
	[5425] = 150,
	-- Wort der Vielseitigkeit +150
	[5426] = 150,
	
	
	-- Bindung des kritischen Treffers +200
	[5427] = 200,
	-- Bindung der Tempos +200
	[5428] = 200,
	-- Bindung der Meisterschaft +200
	[5429] = 200,
	-- Bindung der Vielseitigkeit +200
	[5430] = 200,
	
	--------- CLOAKS ---------
	
	-- Wort der Stärke +150
	[5431] = 150,
	-- Wort der Beweglichkeit +150
	[5432] = 150,
	-- Wort der Intelligenz +150
	[5433] = 150,
	
	
	-- Bindung der Stärke +200
	[5434] = 200,
	-- Bindung der Beweglichkeit +200
	[5435] = 200,
	-- Bindung der Intelligenz +200
	[5436] = 200,
	
	--------- NECK ---------
	
	-- Mal der Klaue
	[5437] = 200,
	-- Mal der fernen Armee
	[5438] = 200,
	-- Mal des verborgenen Satyrs
	[5439] = 200,
	-- Mal des schweren Balgs
	[5889] = 200,
	-- Mal des erfahrenen Soldaten
	[5890] = 200,
	-- Mal der uralten Priesterin
	[5891] = 200,
}

local flasks = {
	
	-- Int Flask
	[188031] = 1300,
	-- Agi Flask
	[188033] = 1300,
	-- Str Flask
	[188034] = 1300,
	-- Stamina Flask
	[188035] = 1950
	
}

local food = {

	[201330]=225,
	[201332]=225,
	[201223]=225,
	[201334]=225,
	[201336]=225,
	[225598]=300,
	[225599]=300,
	[225597]=300,
	[225600]=300,
	[225601]=300,
	[225603]=375,
	[225604]=375,
	[225602]=375,
	[225605]=375,
	[225606]=375,
}

-------------------------------------------------------------------------------------------------------------------------------
		-------------------------------------------------  Preferences  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local addonName 						= 			"Brave Reward"
local bracketColor						=			"|cffFF4500"
local colorReset 						= 			"|r"
local bracketO 							= 			bracketColor .. "<" .. colorReset
local bracketC 							= 			bracketColor .. ">" .. colorReset
local prefixColor 						= 			"|cffffcc00"
local messageColor 						= 			"|cff00ccff"
local difficultyColor					=			"|cffFF4500"  --DIFFICULTY COLOR
local prefix 							= 			bracketO .. prefixColor .. addonName .. colorReset .. bracketC
local bigIntPrefix 						= 			"."
local AHLoaded 							= 			addonName .. " was loaded successfully."
local options 							=			{}
local difficulty						=			""
local difficulty_strings				=			{}
local rolls								=			{}

local slotsToCheck						=			{"NeckSlot", "BackSlot", "Finger0Slot", "Finger1Slot"}
local bonusToSlot						=			{5, 3, 3, 3}
local bonusToAura						=			{["Flask"] = 10, ["Buffood"] = 5}
local bonus								=			0
local FlaskName_eng						=			"Flask"
local FlaskName_ger						=			"Fläschchen"


local msgData, length, result_raw, result, result_sec, result_thrd, result_min, result_max

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  Events  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local function RegisterEvents(self, ...)
	for i=1,select('#', ...) do
		self:RegisterEvent(select(i, ...))
	end
end

f.RegisterEvents = RegisterEvents
f:RegisterEvents("PLAYER_REGEN_ENABLED", "CHAT_MSG_SYSTEM", "PLAYER_REGEN_DISABLED", "PLAYER_TARGET_CHANGED", "ADDON_LOADED", "PLAYER_ENTERING_WORLD", "ZONE_CHANGED", "ZONE_CHANGED_INDOORS", "UNIT_INVENTORY_CHANGED")

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  CORE - BEGIN  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

function BraveReward:fadeInBossIcon()
	
	for key in pairs(bossIconPool) do
		BraveReward:fadeInFrame(bossIconPool[key])
	end
	
end

function BraveReward:hideBossIcon()

	for key in pairs(bossIconPool) do
		BraveReward:fadeOutFrame(bossIconPool[key], true)
	end

end

function BraveReward:formatIntToComma(str)

    str = tostring(str)   -- now you can feed it numbers instead of strings
    local prefix, number, suffix = str:match"(%D*%d)(%d+)(%D*)"
	if number ~= nil then
		return prefix .. number:reverse():gsub("(%d%d%d)","%1" .. bigIntPrefix):reverse() .. suffix
	end
end

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  INTERNAL MESSAGE  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------


function BraveReward:newMsg(msg)
	print(prefix .. messageColor .. " " .. msg .. colorReset)
end


-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  PROFILE CONFIG  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

local defaults = {
    profile = {
		enableAnimations				=			false,
    },
}

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  ON INITIALIZE  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

function BraveReward:OnInitialize()

	--[[local screenRes						=			({GetScreenResolutions()})[GetCurrentResolution()]
	local resVals 							=			BraveReward:split(screenRes, "x")
	local screenResX						=			resVals[1]
	local screenResY						=			resVals[2]
	screenResX_start						=			(screenResX / 2) * -1
	screenResX_end							=			screenResX / 2
	screenResY_start						=			(screenResY / 2) * -1
	screenResY_end							=			screenResY / 2]]--

	-- Called when the addon is loaded
    self.db = LibStub("AceDB-3.0"):New("BraveRewardDB", defaults, true)

		--[[ACR:RegisterOptionsTable(ADHEALTH, options)
			local optionFrame = AceConfigDialog:AddToBlizOptions(ADHEALTH, ADHEALTH)

			self:RegisterChatCommand("ah", function() 
			
				InterfaceOptionsFrame_OpenToCategory(optionFrame) 
			
			end, false)
			self:RegisterChatCommand("BraveReward", function()
			
				InterfaceOptionsFrame_OpenToCategory(optionFrame)
				
			end)
			self:RegisterChatCommand("ahloaded", function()
			
				BraveReward:showLoadedBosses()
				
			end)]]--
			
			
		BraveReward:newMsg(AHLoaded);
end



----------------------------------------
-- End of Options Table
----------------------------------------

function BraveReward:split(source, delimiters)
        local elements = {}
        local pattern = '([^'..delimiters..']+)'
        string.gsub(source, pattern, function(value) elements[#elements + 1] =     value;  end);
        return elements
  end

  
function BraveReward:round(int)
  return int>=0 and math.floor(int+0.5) or math.ceil(int-0.5)
end

function BraveReward:tablelength(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

function BraveReward:inTable(tbl, item)
    for key, value in pairs(tbl) do
	
        if tonumber(key) == item then 
			return true
		end
		
    end
    return false
end

function BraveReward:StringContains(str, value)
	return string.match(' '..str..' ', '%W'..value..'%W') ~= nil
end

function BraveReward:LoadInventories()

	for i=1,40 do
		NotifyInspect(i)
	end
end

function BraveReward:LoadEnchants(itemLink)
	
		local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4,
		Suffix, Unique, LinkLvl, Name = string.find(itemLink,
		"|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")

	if(Enchant ~= "") then
		return BraveReward:inTable(enchants, tonumber(Enchant))
	else
		return false
	end
end

function BraveReward:GetUnitAura(unit, tbl)
	
	local auras = {}
	local auraID = 0
	local i = 1
	
	repeat
		n,_,_,_,_,_,_,_,_,_,auraID = UnitAura(unit, i)
		if auraID == nil then break end
		
		if (BraveReward:inTable(tbl, auraID)) and auraID ~= nil then
			return auraID
		end
		
		-- print(n .. ": " .. auraID)
		
		i = i + 1
	until auraID == nil
	
	return false
end

-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  CORE FUNCTION  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

function BraveReward:GetUnit(name)
	
	local unitID = nil

	for i=1, 40 do
		local raidname = GetRaidRosterInfo(i)
		
		if(name == raidname) then
			unitID = "raid" .. i
		end
		
		if(name == nil) then
			break
		end
		
	end
	
	return unitID
end

function BraveReward:ProcessRoll(data)
	
	local unitData = {}
	local enchant = 0
	bonus = 0
	
	
	msgData = BraveReward:split(select(1, data), " ")
		if(msgData[2] == "würfelt." or msgData[2] == "rolls.") then
			-- Get Player name
			player = msgData[1]
			
			-- Get roll result
			result = msgData[4]
			
			-- Get last part of roll String (XXX (1-100))
			result_raw = msgData[5]
			
			-- Process string to split min and max values
				result_sec = BraveReward:split(result_raw, "(")[1]
				result_thrd = BraveReward:split(result_sec, ")")[1]
				result_min = BraveReward:split(result_thrd, "-")[1]
				result_max = BraveReward:split(result_thrd, "-")[2]
				
			-- Determine data position in table
			length = BraveReward:tablelength(rolls) + 1
			
			
			local rollUnit = BraveReward:GetUnit(player)
			if CanInspect(rollUnit) then
				for i=1, BraveReward:tablelength(slotsToCheck) do
				
					unitData[i] = GetInventoryItemLink(rollUnit,GetInventorySlotInfo(slotsToCheck[i]))
					if(unitData[i] and unitData[i] ~= nil) then
					
						enchant = BraveReward:LoadEnchants(unitData[i])
					
						-- If Enchant is specified and valid to use
						if(enchant ~= nil and enchant ~= false) then
						
							-- Add bonus of piece
							bonus = bonus + bonusToSlot[i]
						end
						
					end
				end
				
				local unitFlask = BraveReward:GetUnitAura(rollUnit, flasks)
				if unitFlask ~= false and unitFlask ~= nil then
					bonus = bonus + bonusToAura["Flask"]
				end
				local unitFood = BraveReward:GetUnitAura(rollUnit, food)
				if unitFood ~= false and unitFood ~= nil then
					bonus = bonus + bonusToAura["Buffood"]
				end
				-- local unitBuffood = BraveReward:GetUnitAura(rollUnit, flasks)
			
				-- ClearInspectPlayer("player")
				
				
				
				-- Add Data to table
				rolls[length] = {["player"] = player, ["result"] = result, ["result_min"] = result_min, ["result_max"] = result_max, ["bonus"] = bonus}
			
				-- Output via internal AddOn Message
				BraveReward:newMsg(rolls[length]["player"] .. " rolled " .. rolls[length]["result"] + rolls[length]["bonus"] .. " (" .. rolls[length]["result"] .. " (+" .. rolls[length]["bonus"] .. ")) (" .. rolls[length]["result_min"] .. " - " .. rolls[length]["result_max"] .. ")")
			end
		end
end


-------------------------------------------------------------------------------------------------------------------------------
	-------------------------------------------------  EVENT HANDLER  -------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------


f:SetScript("OnEvent",function(self,event, ...)

	BraveReward:LoadInventories()

	if IsInRaid() then
	
		if event == "CHAT_MSG_SYSTEM" then
			
			BraveReward:ProcessRoll(...)
			
		end
	end
	
	if event == "UNIT_INVENTORY_CHANGED" then
		
		-- print(event)
		BraveReward:LoadInventories()
		
	end
	


	-------------------------------------------------------------------------------------------------------------------------------
		-------------------------------------------------  ON LOGIN  -------------------------------------------------
	-------------------------------------------------------------------------------------------------------------------------------

	if event == "PLAYER_ENTERING_WORLD" and IsAddOnLoaded("BraveReward") then
		
		-- BraveReward:newMsg("Brave Reward locked'n loaded.")
		
	end

end)